'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ActionModal = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _RTGFade = require('./RTGFade');

var _RTGFade2 = _interopRequireDefault(_RTGFade);

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ActionModal = function ActionModal(_ref) {
	var renderTrigger = _ref.renderTrigger,
	    defaultCloseModalButton = _ref.defaultCloseModalButton,
	    renderCloseModalButton = _ref.renderCloseModalButton,
	    renderHeader = _ref.renderHeader,
	    dataTestId = _ref.dataTestId,
	    renderBody = _ref.renderBody,
	    buttons = _ref.buttons,
	    className = _ref.className,
	    modalIsOpen = _ref.modalIsOpen,
	    toggleModal = _ref.toggleModal,
	    renderButtons = _ref.renderButtons,
	    modalDialogContainerClassNameAppend = _ref.modalDialogContainerClassNameAppend,
	    modalDialogContainerClassNameOverride = _ref.modalDialogContainerClassNameOverride,
	    modalDialogContainerStyle = _ref.modalDialogContainerStyle,
	    useStylesheet = _ref.useStylesheet;

	if (useStylesheet) {
		document.head.appendChild(document.createElement('style')).textContent = _defaultStyles.styleSheet;
	}
	var getTriggerProps = function getTriggerProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick = _ref2.onClick,
		    className = _ref2.className,
		    props = _objectWithoutProperties(_ref2, ['onClick', 'className']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				toggleModal();
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: className ? 'actionmodal__trigger ' + className : 'actionmodal__trigger'

		}, props);
	};
	return _react2.default.createElement(
		_react.Fragment,
		null,
		renderTrigger && renderTrigger({ getTriggerProps: getTriggerProps }),
		_react2.default.createElement(
			_RTGFade2.default,
			{
				duration: 100,
				style: _defaultStyles.defaultStyles.background,
				className: 'modal__background',
				'in': modalIsOpen,
				onClick: toggleModal
			},
			_react2.default.createElement(_ModalDialog2.default, {
				dataTestId: dataTestId,
				classNameAppend: modalDialogContainerClassNameAppend,
				classNameOverride: modalDialogContainerClassNameOverride,
				style: modalDialogContainerStyle,
				defaultCloseModalButton: defaultCloseModalButton,
				renderHeader: renderHeader,
				renderBody: renderBody,
				toggleModal: toggleModal,
				renderButtons: renderButtons,
				renderCloseModalButton: renderCloseModalButton
			})
		)
	);
};

exports.ActionModal = ActionModal;
ActionModal.defaultProps = {
	defaultCloseModalButton: true
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withHandlers)({
	toggleModal: function toggleModal(_ref3) {
		var setModalIsOpenTo = _ref3.setModalIsOpenTo;
		return function () {
			console.log('toggling');
			setModalIsOpenTo(function (x) {
				return !x;
			});
		};
	}
}), (0, _recompose.setPropTypes)({ modalIsOpen: _propTypes2.default.bool.isRequired, toggleModal: _propTypes2.default.func.isRequired }));

exports.default = enhance(ActionModal);